#include <X3DTK/kernel.h>
#include <X3DTK/X3D/scenegraph.h>
#include <X3DTK/X3D/scenesaver.h>
#include <X3DTK/X3D/worldcoordtranslator.h>
#include <iostream>

using namespace X3DTK;
using namespace std;

int main(int argc, char *argv[])
{
  if (argc <= 2)
  {
    cerr << "usage: X3DWorldCoordTranslator input output" << endl;
    exit(0);
  }

  // DefaultLoader to load the default X3D Nodes.
  X3D::Loader *loader = Singleton<X3D::Loader>::getInstance();
  X3D::SceneSaver *sceneSaver = Singleton<X3D::SceneSaver>::getInstance();
  X3D::WorldCoordTranslator *translator = Singleton<X3D::WorldCoordTranslator>::getInstance();
  
  // Loads the scene.
  X3D::Scene *s = loader->load(argv[1], true);
  cout << "translating" << endl;
  translator->translate(s);
  cout << "translated" << endl;
    
  sceneSaver->saveAs(s, argv[2]);
  
  return 1;
}
