#include "GL_X3DComposedGeometryNode.h"

namespace X3DTK {
namespace GL {

X3DComposedGeometryNode::X3DComposedGeometryNode()
: X3DGeometryNode()
{
  define(Recorder<X3DComposedGeometryNode>::getTypeName("X3DComposedGeometryNode", "Rendering"));
  
  define(Recorder<X3DComposedGeometryNode, SFBool>::getAttribute("ccw", &X3DComposedGeometryNode::_ccw, true));
  define(Recorder<X3DComposedGeometryNode, SFBool>::getAttribute("solid", &X3DComposedGeometryNode::_solid, false));
  define(Recorder<X3DComposedGeometryNode, SFBool>::getAttribute("color", &X3DComposedGeometryNode::_color, false));
  define(Recorder<X3DComposedGeometryNode, SFBool>::getAttribute("texCoord", &X3DComposedGeometryNode::_texCoord, false));
  define(Recorder<X3DComposedGeometryNode, SFBool>::getAttribute("normalPerVertex", &X3DComposedGeometryNode::_normalPerVertex, false));
}

X3DComposedGeometryNode::~X3DComposedGeometryNode()
{
}

void X3DComposedGeometryNode::setCcw(const SFBool &ccw)
{
  _ccw = ccw;
}

void X3DComposedGeometryNode::setSolid(const SFBool &solid)
{
  _solid = solid;
}

void X3DComposedGeometryNode::setColor(const SFBool &color)
{
  _color = color;
}

void X3DComposedGeometryNode::setTexCoord(const SFBool &texCoord)
{
  _texCoord = texCoord;
}

void X3DComposedGeometryNode::setNormalPerVertex(const SFBool &normalPerVertex)
{
  _normalPerVertex = normalPerVertex;
}

void X3DComposedGeometryNode::setVertexFormat(const GLenum &format)
{
  _format = format;
}

}
}
