#include "MESH_Transform.h"

namespace X3DTK {
namespace MESH {

Transform::Transform()
: X3DGroupingNode(), _center(SFVec3f(0.0f, 0.0f, 0.0f)), _rotation(SFRotation(0.0f, 0.0f, 1.0f, 0.0f)), _scale(SFVec3f(1.0f, 1.0f, 1.0f)), _scaleOrientation(SFRotation(0.0f, 0.0f, 1.0f, 0.0f)), _translation(SFVec3f(0.0f, 0.0f, 0.0f))
{
  define(Recorder<Transform>::getTypeName("Transform"));
}

Transform::~Transform()
{
}

void Transform::setCenter(const SFVec3f &center)
{
  _center = center;
}

void Transform::setRotation(const SFRotation &rotation)
{
  _rotation = rotation;
}

void Transform::setScale(const SFVec3f &scale)
{
  _scale = scale;
}

void Transform::setScaleOrientation(const SFRotation &scaleOrientation)
{
  _scaleOrientation = scaleOrientation;
}

void Transform::setTranslation(const SFVec3f &translation)
{
  _translation = translation;
}

SFMatrix34f Transform::getTransform() const 
{
  return SFMatrix34f(_translation, _center, _rotation, _scaleOrientation, _scale);
}

}
}
