#include "X3D_X3DLightNode.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

X3DLightNode::X3DLightNode()
: X3DChildNode()
{
  define(Recorder<X3DLightNode>::getTypeName("X3DLightNode", "Lighting"));
  
  define(Recorder<X3DLightNode, SFFloat>::getAttribute("ambientIntensity", &X3DLightNode::_ambientIntensity, 0.0f));
  define(Recorder<X3DLightNode, SFColor>::getAttribute("color", &X3DLightNode::_color, SFColor(1.0f,1.0f,1.0f)));
  define(Recorder<X3DLightNode, SFFloat>::getAttribute("intensity", &X3DLightNode::_intensity, 1.0f));
  define(Recorder<X3DLightNode, SFBool>::getAttribute("on", &X3DLightNode::_on, true));      
}

X3DLightNode::~X3DLightNode()
{
}

void X3DLightNode::setAmbientIntensity(const SFFloat &ambientIntensity)
{
  _ambientIntensity = ambientIntensity;
}

void X3DLightNode::setColor(const SFColor &color)
{
  _color = color;
}

void X3DLightNode::setIntensity(const SFFloat &intensity)
{
  _intensity = intensity;
}

void X3DLightNode::setOn(const SFBool &on)
{
  _on = on;
}

}
}
