#include "X3D_NurbsPositionInterpolator.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

NurbsPositionInterpolator::NurbsPositionInterpolator()
: X3DInterpolatorNode()
{
  define(Recorder<NurbsPositionInterpolator>::getTypeName("NurbsPositionInterpolator", "NURBS"));
  
  define(Recorder<NurbsPositionInterpolator, SFBool>::getAttribute("fractionAbsolute", &NurbsPositionInterpolator::_fractionAbsolute, true));
  define(Recorder<NurbsPositionInterpolator, SFInt32>::getAttribute("dimension", &NurbsPositionInterpolator::_dimension, 0));
  define(Recorder<NurbsPositionInterpolator, MFVec3f>::getAttribute("keyValue", &NurbsPositionInterpolator::_keyValue, MFVec3f()));
  define(Recorder<NurbsPositionInterpolator, MFDouble>::getAttribute("keyWeight", &NurbsPositionInterpolator::_keyWeight, MFDouble()));
  define(Recorder<NurbsPositionInterpolator, MFDouble>::getAttribute("knot", &NurbsPositionInterpolator::_knot, MFDouble()));
  define(Recorder<NurbsPositionInterpolator, SFInt32>::getAttribute("order", &NurbsPositionInterpolator::_order, 3));
}

NurbsPositionInterpolator::~NurbsPositionInterpolator()
{
}

void NurbsPositionInterpolator::setFractionAbsolute(const SFBool &fractionAbsolute)
{
  _fractionAbsolute = fractionAbsolute;
}

void NurbsPositionInterpolator::setDimension(const SFInt32 &dimension)
{
  _dimension = dimension;
}

void NurbsPositionInterpolator::setKeyValue(const MFVec3f &keyValue)
{
  _keyValue = keyValue;
}

void NurbsPositionInterpolator::setKeyWeight(const MFDouble &keyWeight)
{
  _keyWeight = keyWeight;
}

void NurbsPositionInterpolator::setKnot(const MFDouble &knot)
{
  _knot = knot;
}

void NurbsPositionInterpolator::setOrder(const SFInt32 &order)
{
  _order = order;
}

}
}
