#include "X3D_TriangleStripSet.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

TriangleStripSet::TriangleStripSet()
: X3DComposedGeometryNode()
{
  define(Recorder<TriangleStripSet>::getTypeName("TriangleStripSet", "Rendering"));
  
  define(Recorder<TriangleStripSet, SFBool>::getAttribute("convex", &TriangleStripSet::_convex, true));
  define(Recorder<TriangleStripSet, SFFloat>::getAttribute("creaseAngle", &TriangleStripSet::_creaseAngle, 0.0f));
  define(Recorder<TriangleStripSet, MFInt32>::getAttribute("stripCount", &TriangleStripSet::_stripCount, MFInt32()));
}

TriangleStripSet::~TriangleStripSet()
{
}

void TriangleStripSet::setConvex(const SFBool &convex)
{
  _convex = convex;
}

void TriangleStripSet::setCreaseAngle(const SFFloat &creaseAngle)
{
  _creaseAngle = creaseAngle;
}

void TriangleStripSet::setStripCount(const MFInt32 &stripCount)
{
  _stripCount  = stripCount;
}

}
}
