TEMPLATE = lib 
CONFIG *= staticlib
TARGET = x3dnodes

VPATH = Core \
        Geometry3D \
        Grouping \
        Rendering \
        Shape \
        Texturing \ 
        Interpolation \
        Lighting \
        NURBS \
        Networking \
        Navigation
        
HEADERS = X3D_Scene.h \
          X3D_X3DNode.h \
	  X3D_X3DObject.h \
	  X3D_Cylinder.h \
          X3D_Cone.h \
	  X3D_Sphere.h \
          X3D_Box.h \
          X3D_IndexedFaceSet.h \
	  X3D_X3DBoundedObject.h \
	  X3D_X3DChildNode.h \
	  X3D_X3DGroupingNode.h \
	  X3D_Group.h \
          X3D_StaticGroup.h \
	  X3D_Transform.h \
          X3D_Switch.h \
          X3D_Color.h \
          X3D_ColorRGBA.h \
          X3D_Coordinate.h \
          X3D_IndexedLineSet.h \
          X3D_Normal.h \
          X3D_PointSet.h \
          X3D_TriangleFanSet.h \
          X3D_TriangleSet.h \
          X3D_TriangleStripSet.h \
          X3D_X3DColorNode.h \
  	  X3D_X3DComposedGeometryNode.h \
          X3D_X3DCoordinateNode.h \
          X3D_X3DGeometricPropertyNode.h \
	  X3D_X3DGeometryNode.h \
          X3D_X3DNormalNode.h \
	  X3D_Appearance.h \
	  X3D_FillProperties.h \
	  X3D_LineProperties.h \
	  X3D_Material.h \
	  X3D_Shape.h \
	  X3D_X3DAppearanceChildNode.h \
	  X3D_X3DAppearanceNode.h \
	  X3D_X3DMaterialNode.h \
	  X3D_X3DShapeNode.h \
	  X3D_X3DTextureNode.h \
          X3D_X3DTextureCoordinateNode.h \        
	  X3D_X3DTextureTransformNode.h \
          X3D_X3DTexture2DNode.h \        
          X3D_ImageTexture.h \
          X3D_TextureCoordinate.h \
          X3D_X3DTextureTransform2DNode.h \
          X3D_TextureTransform.h \
          X3D_X3DUrlObject.h \
          X3D_Inline.h \
          X3D_X3DSensorNode.h \
          X3D_Collision.h
                    
SOURCES = X3D_Scene.cpp \
          X3D_X3DNode.cpp \
	  X3D_X3DObject.cpp \
	  X3D_Cylinder.cpp \
          X3D_Cone.cpp \
	  X3D_Sphere.cpp \
          X3D_Box.cpp \
          X3D_IndexedFaceSet.cpp \
	  X3D_X3DBoundedObject.cpp \
	  X3D_X3DChildNode.cpp \
	  X3D_X3DGroupingNode.cpp \
	  X3D_Group.cpp \
          X3D_StaticGroup.cpp \
	  X3D_Transform.cpp \
          X3D_Switch.cpp \
          X3D_Color.cpp \
          X3D_ColorRGBA.cpp \
          X3D_Coordinate.cpp \
          X3D_IndexedLineSet.cpp \
          X3D_Normal.cpp \
          X3D_PointSet.cpp \
          X3D_TriangleFanSet.cpp \
          X3D_TriangleSet.cpp \
          X3D_TriangleStripSet.cpp \
          X3D_X3DColorNode.cpp \
  	  X3D_X3DComposedGeometryNode.cpp \
          X3D_X3DCoordinateNode.cpp \
          X3D_X3DGeometricPropertyNode.cpp \
	  X3D_X3DGeometryNode.cpp \
          X3D_X3DNormalNode.cpp \
	  X3D_Appearance.cpp \
	  X3D_FillProperties.cpp \
	  X3D_LineProperties.cpp \
	  X3D_Material.cpp \
	  X3D_Shape.cpp \
	  X3D_X3DAppearanceChildNode.cpp \
	  X3D_X3DAppearanceNode.cpp \
	  X3D_X3DMaterialNode.cpp \
	  X3D_X3DShapeNode.cpp \
	  X3D_X3DTextureNode.cpp \
          X3D_X3DTextureCoordinateNode.cpp \        
	  X3D_X3DTextureTransformNode.cpp \
          X3D_X3DTexture2DNode.cpp \        
          X3D_ImageTexture.cpp \
          X3D_TextureCoordinate.cpp \
          X3D_X3DTextureTransform2DNode.cpp \
          X3D_TextureTransform.cpp \
          X3D_X3DUrlObject.cpp \
          X3D_Inline.cpp \
          X3D_X3DSensorNode.cpp \
          X3D_Collision.cpp     
         
# --------------------
#  Lighting component
# --------------------

HEADERS += X3D_X3DLightNode.h \
           X3D_DirectionalLight.h \
           X3D_PointLight.h \
           X3D_SpotLight.h

SOURCES += X3D_X3DLightNode.cpp \
           X3D_DirectionalLight.cpp \
           X3D_PointLight.cpp \
           X3D_SpotLight.cpp

# -------------------------
#  Interpolation component
# -------------------------

HEADERS += X3D_X3DInterpolatorNode.h \
           X3D_ColorInterpolator.h \
           X3D_CoordinateInterpolator.h \
           X3D_CoordinateInterpolator2D.h \
           X3D_NormalInterpolator.h \
           X3D_OrientationInterpolator.h \
           X3D_PositionInterpolator.h \
           X3D_PositionInterpolator2D.h \
           X3D_ScalarInterpolator.h

SOURCES += X3D_X3DInterpolatorNode.cpp \
           X3D_ColorInterpolator.cpp \
           X3D_CoordinateInterpolator.cpp \
           X3D_CoordinateInterpolator2D.cpp \
           X3D_NormalInterpolator.cpp \
           X3D_OrientationInterpolator.cpp \
           X3D_PositionInterpolator.cpp \
           X3D_PositionInterpolator2D.cpp \
           X3D_ScalarInterpolator.cpp

# -----------------
#  NURBS component
# -----------------

HEADERS += X3D_X3DParametricGeometryNode.h \
           X3D_Contour2D.h \
           X3D_ContourPolyline2D.h \
           #CoordinateDeformer.h \
           X3D_NurbsCurve.h \
           X3D_NurbsCurve2D.h \
           X3D_NurbsGroup.h \
           X3D_NurbsPositionInterpolator.h \
           X3D_NurbsSurface.h \
           X3D_NurbsTextureSurface.h \
           X3D_TrimmedSurface.h

SOURCES += X3D_X3DParametricGeometryNode.cpp \
           X3D_Contour2D.cpp \
           X3D_ContourPolyline2D.cpp \
           #CoordinateDeformer.cpp \
           X3D_NurbsCurve.cpp \
           X3D_NurbsCurve2D.cpp \
           X3D_NurbsGroup.cpp \
           X3D_NurbsPositionInterpolator.cpp \
           X3D_NurbsSurface.cpp \
           X3D_NurbsTextureSurface.cpp \
           X3D_TrimmedSurface.cpp

include(../../X3DToolKit.pri)

INCLUDEPATH += ../../../include/X3DTK
INCLUDEPATH += ../../../include/X3DTK/private

DESTDIR  = ../../../lib/static
OBJECTS_DIR = ../../../obj
