#include "GL_Updater.h"
#include "DFSGraphTraversal.h"
#include "GL_UpdaterCoreVisitor.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace GL {

Updater::Updater()
: X3DOnePassProcessor()
{
  setGraphTraversal(new DFSGraphTraversal());
  setComponentVisitor(new UpdaterCoreVisitor());
}

Updater::~Updater()
{
  Singleton<UpdaterStateVariables>::removeInstance();
}

void Updater::update(X3DNode *N)
{
  getGraphTraversal()->traverse(N);
}

}
}
