#include "X3D_FileValidator.h"
#include "DFSGraphTraversal.h"
#include "X3D_FileValidatorCoreVisitor.h"
#include "X3D_FileValidatorGeometry3DVisitor.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

FileValidator::FileValidator()
: X3DOnePassProcessor()
{
  setGraphTraversal(new DFSGraphTraversal());
  setComponentVisitor(new FileValidatorCoreVisitor());
  setComponentVisitor(new FileValidatorGeometry3DVisitor());
}

FileValidator::~FileValidator()
{
  Singleton<FileValidatorStateVariables>::removeInstance();
}

bool FileValidator::validate(SFNode N) const
{
  Singleton<FileValidatorStateVariables>::getInstance()->setValidity(true);
  traverse(N);
  
  return Singleton<FileValidatorStateVariables>::getInstance()->getValidity();
}

}
}
