#include "X3D_WorldCoordTranslator.h"
#include "X3D_WorldCoordTranslatorMulCoreVisitor.h"
#include "X3D_WorldCoordTranslatorMulGroupingVisitor.h"
#include "X3D_WorldCoordTranslatorMulRenderingVisitor.h"
#include "X3D_WorldCoordTranslatorMulNavigationVisitor.h"
#include "X3D_WorldCoordTranslatorShareCoreVisitor.h"
#include "X3D_WorldCoordTranslatorReplaceGroupingVisitor.h"
#include "DFSGraphTraversal.h"
#include "X3D_X3DNode.h"
#include "X3D_Scene.h"

namespace X3DTK {
namespace X3D {

WorldCoordTranslator::WorldCoordTranslator()
{
  setGraphTraversal("Share", new DFSGraphTraversal());
  setComponentVisitor("Share", new WorldCoordTranslatorShareCoreVisitor());

  setGraphTraversal("Mul", new DFSGraphTraversal());
//  graphTraversalMap["Mul"]->setComponentVisitor(new WorldCoordTranslatorMulCoreVisitor());
  setComponentVisitor("Mul", new WorldCoordTranslatorMulGroupingVisitor());
  setComponentVisitor("Mul", new WorldCoordTranslatorMulRenderingVisitor());
//  graphTraversalMap["Mul"]->setComponentVisitor(new WorldCoordTranslatorMulNavigationVisitor());
    
  setGraphTraversal("Replace", new DFSGraphTraversal());
  setComponentVisitor("Replace", new WorldCoordTranslatorReplaceGroupingVisitor());
}

WorldCoordTranslator::~WorldCoordTranslator()
{
  Singleton<WorldCoordTranslatorStateVariables>::removeInstance();
}

void WorldCoordTranslator::translate(Scene *S)
{
  translate(static_cast<X3DNode *>(S));
  
  S->getProcessHistory().addEntry("X3D::WorldCoordTranslator");
}

void WorldCoordTranslator::translate(SFNode N)
{
  Singleton<WorldCoordTranslatorStateVariables>::getInstance()->init();
  traverse("Share", N);
  Singleton<WorldCoordTranslatorStateVariables>::getInstance()->finish();
  
  Singleton<WorldCoordTranslatorStateVariables>::getInstance()->init();
  traverse("Mul", N);
  Singleton<WorldCoordTranslatorStateVariables>::getInstance()->finish();
  
  Singleton<WorldCoordTranslatorStateVariables>::getInstance()->init();
  traverse("Replace", N);
  Singleton<WorldCoordTranslatorStateVariables>::getInstance()->finish();
}

}
}
